# Sensei Newsletter no 5.

## Topics for this newsletter:

1. Web & Mobile News
2. AI in programming
3. Articles & links
4. Upcoming Events

## 1. Web & Mobile News

A [State of JS survey 2022](https://2022.stateofjs.com/) is out. Let's check what are the trends for 2023:

- After the top SPA frameworks became standard, interest in them has fallen. The main focus of the community is now on meta-frameworks (next.js, remix, SvelteKit, Nuxt or even SolidStart). Looks like those meta-frameworks will drive web development rather than their bases.
- [SSR, SSG, CSR](https://www.makeuseof.com/nextjs-rendering-methods-csr-ssr-ssg-isr) are often mixed within one app, because of better support by those meta-frameworks.
- Edge functions (serverless) are growing in popularity. There is a need for them as 'time to interactive' becomes crucial for good SEO.
- Monorepo becoming the new standard for mid and large applications
  - It enables us to share types across FE and BE easily. On the API level, there seems to be a new rising star in form of [tRCP](https://trpc.io/)
- [Vite](https://vitejs.dev/) and [Turbopack](https://turbo.build/pack) seem to replace Webpack in near future.
- AI in programming.. lets check it separately ;)

## 2. AI in programming

Artificial intelligence (AI) has been generating a lot of buzz in the programming world recently. If you're not familiar with the concept, check out the [OpenAI chat](https://chat.openai.com/chat).

In this article, we'll explore the use of AI in programming and whether or not it's a good idea to use it in your daily work.

As an example, let's consider the following question asked in the OpenAI chat:

`Give me a javascript function, which returns n prime numbers.`

I won't show the generated code here as it would be too long. Try to ask the AI yourself.

It's important to note that the code generated by the AI is not a copy of a function found on the internet. Instead, it's an average mixture of code related to similar functions found online (written with all JS rules and limitations in mind). The AI model is so good that there's a good chance the generated code is valid and runnable. However, there are a few things to keep in mind:

- The AI uses an average of what it found and it may not know about newer JS syntax (it does not know anything newer than from 2021).
- The generated code is not optimized and may require further improvements. I asked for performance optimization and got some, including a reference to the 'Sieve of Eratosthenes' algorithm.
- AI often uses more code than a senior programmer would.

_While the AI-generated code may seem useful at first glance, there are a few drawbacks to consider:_

- If you ask for more improvements, the AI may start to deviate from your original question.
- The code has not been run or tested and may contain bugs or errors. Even in an algorithm.
- The output may contain features from different versions of the language or deprecated code, or the AI tries to convince you to use a non-existent libraries package.
- If you ask trivial questions like `What is a sum of 465465 and 78965?` The answer will be wrong... AI told me it is 543430, in reality, it is 544430. Why, because it does not know how to count. It handles numbers as strings; it does best guess based on similar assignments read in learning data. Sometimes it is correct, sometimes not.
- You won't be able to use it in your code if it is more complex and the code is spread across many files. It would take ages to feed the AI with all your code, and in the meantime, it would forget what you started with.

As you can see, it is far from perfect and probably the biggest disadvantage of using it is that it never tells you, it does not know anything. It rather 'lies' to you and fabricates some nonsense. Compared to a human it doesn't have any feeling for distinguishing how correct or incorrect it is. It is not intelligent at all :D

**Conclusion**

Give it a try. You will see if it makes sense for you.
You should approach the generated code, with caution, the same as any other code copied from Stack overflow or elsewhere. **Do not copy and use code you don't understand.** The big advantage of this AI is that you can ask the AI to explain some parts of the code, give examples etc.

I would say, it is particularly good for producing simple algorithms, and explaining code you don't understand. Scaffolding new components or even small projects.

**Always make sure that the generated code works as intended!**

## 3. Articles & links

### Web & Mobile

- [You don't (may not) need Lodash/Underscore](https://github.com/you-dont-need/You-Dont-Need-Lodash-Underscore#readme) - Replacing JavaScript utility libraries with native JS(TS)
- [The 6 JavaScript Projects to watch in 2023](https://byteofdev.com/posts/javascript-projects-2022/)
- [Deep Cloning Objects in JavaScript, the Modern Way](https://www.builder.io/blog/structured-clone)
-

### DevOps

- [Software engineering at google](https://abseil.io/resources/swe-book/html/toc.html) - Although this book is not strictly about DevOps, it covers a lot of topics related to DevOps as a time and change in software engineering, CI/CD, testing... And it is also free to read online.
- [who watches the watchmen?](https://simme.dev/posts/who-watches-the-watchmen/) - I just cannot resist recommending an article with the same title as my favourite comic book. And the article also deals with issues that we don't often think about: How do we know if our observability really works?
- [Kubernetes is a red flag](https://www.jeremybrown.tech/8-kubernetes-is-a-red-flag-signalling-premature-optimisation/) - And the controversial one as last. Is the overhead of managing Kubernetes really justified? Maybe you would be better off with just netlify?

## 4. Upcoming Events
